| package |
package := Package name: 'SIXX-Examples'.
package paxVersion: 0;
	basicComment: ''.


package classNames
	add: #SixxCustomStoreLoadExample;
	add: #SixxExamples;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'SIXX-Core';
	yourself).

package!

"Class Definitions"!

Object subclass: #SixxCustomStoreLoadExample
	instanceVariableNames: 'id cachedData'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'instances cachedData'!
Object subclass: #SixxExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

SixxCustomStoreLoadExample guid: (GUID fromString: '{02DA26E5-A1DC-4842-AD90-5F5C3A7FE244}')!
SixxCustomStoreLoadExample comment: ''!
!SixxCustomStoreLoadExample categoriesForClass!Kernel-Objects! !
!SixxCustomStoreLoadExample methodsFor!

cachedData
	^cachedData!

cachedData: aValue
	cachedData := aValue!

id
	^id!

id: aNumber
	id := aNumber!

sixxContentOn: aStream indent: level context: dictionary
	"override if you like"

	aStream cr.
	self id 
		sixxOn: aStream
		name: 'id'
		indent: level + 1
		context: dictionary.
	aStream tab: level!

sixxInstVarNamed: instVarName put: aValue
	"override if you like"

	instVarName asString = 'id' ifTrue: [self id: aValue]! !
!SixxCustomStoreLoadExample categoriesFor: #cachedData!accessing!public! !
!SixxCustomStoreLoadExample categoriesFor: #cachedData:!accessing!public! !
!SixxCustomStoreLoadExample categoriesFor: #id!accessing!public! !
!SixxCustomStoreLoadExample categoriesFor: #id:!accessing!public! !
!SixxCustomStoreLoadExample categoriesFor: #sixxContentOn:indent:context:!accessing!public!sixx writing reading! !
!SixxCustomStoreLoadExample categoriesFor: #sixxInstVarNamed:put:!accessing!public!sixx writing reading! !

!SixxCustomStoreLoadExample class methodsFor!

example1
	"SixxCustomStoreLoadExample example1"

	"Writing custom serialization object"

	| inst xml |
	inst := SixxCustomStoreLoadExample random.
	xml := inst sixxString.
	Transcript
		cr;
		show: self name , ' instance sixx is...';
		cr;
		show: xml.
	^xml!

example2
	"SixxCustomStoreLoadExample example2"

	"Reading custom serialization object"

	| xml inst |
	xml := self example1.
	inst := Object readSixxFrom: xml.
	Transcript
		cr;
		show: self name , ' instance is load from XML...';
		cr;
		show: inst printString.
	^inst inspect!

example3
	"SixxCustomStoreLoadExample example3"

	"Writing custom serialization class object"

	| cls xml |
	cls := SixxCustomStoreLoadExample.
	xml := cls sixxString.
	Transcript
		cr;
		show: self name , ' class instance sixx is...';
		cr;
		show: xml.
	^xml!

example4
	"SixxCustomStoreLoadExample example4"

	"Reading custom serialization object"

	| xml cls |
	xml := self example3.
	self instances: nil.	"class instances variable is set to nil"
	cls := self readSixxFrom: xml.
	Transcript
		cr;
		show: self name , ' cls instance is load from XML...';
		cr;
		show: cls printString.	"now class instances variable has been set"
	^self instances inspect!

id: anInteger
	| inst |
	inst := (self new)
				id: anInteger;
				cachedData: thisContext;
				yourself.
	self instances add: inst.
	^inst!

initialize
	"SixxCustomStoreLoadExample initialize"

	instances := OrderedCollection new.	"some unstorable cache data"
	cachedData := thisContext!

instances
	instances isNil ifTrue: [instances := OrderedCollection new].
	^instances!

instances: aValue
	instances := aValue!

random
	^self id: Random new next!

sixxContentOn: aStream indent: level context: dictionary
	"override if you like"

	aStream cr.
	self instances 
		sixxOn: aStream
		name: 'instances'
		indent: level + 1
		context: dictionary.
	aStream tab: level!

sixxInstVarNamed: instVarName put: aValue
	"override if you like"

	instVarName asString = 'instances' ifTrue: [self instances: aValue]! !
!SixxCustomStoreLoadExample class categoriesFor: #example1!accessing!class initialization!examples!instance creation!public!sixx writing reading! !
!SixxCustomStoreLoadExample class categoriesFor: #example2!accessing!class initialization!examples!instance creation!public!sixx writing reading! !
!SixxCustomStoreLoadExample class categoriesFor: #example3!accessing!class initialization!examples!instance creation!public!sixx writing reading! !
!SixxCustomStoreLoadExample class categoriesFor: #example4!accessing!class initialization!examples!instance creation!public!sixx writing reading! !
!SixxCustomStoreLoadExample class categoriesFor: #id:!class initialization!instance creation!public! !
!SixxCustomStoreLoadExample class categoriesFor: #initialize!class initialization!public! !
!SixxCustomStoreLoadExample class categoriesFor: #instances!accessing!class initialization!instance creation!public! !
!SixxCustomStoreLoadExample class categoriesFor: #instances:!accessing!class initialization!instance creation!public! !
!SixxCustomStoreLoadExample class categoriesFor: #random!class initialization!instance creation!public! !
!SixxCustomStoreLoadExample class categoriesFor: #sixxContentOn:indent:context:!accessing!class initialization!instance creation!public!sixx writing reading! !
!SixxCustomStoreLoadExample class categoriesFor: #sixxInstVarNamed:put:!accessing!class initialization!instance creation!public!sixx writing reading! !

SixxExamples guid: (GUID fromString: '{0C2855D0-F2E4-46F1-BA99-9BFF4FDFEF58}')!
SixxExamples comment: ''!
!SixxExamples categoriesForClass!Kernel-Objects! !
!SixxExamples class methodsFor!

example1
	"SixxExamples example1"

	"Create a SIXX string from an object (like #storeString)"

	| dict array xmlString |
	dict := Dictionary new.
	dict at: #Smalltalk put: 'Best'.
	dict at: #Ruby put: 'Cool'.
	dict at: #Java put: 'Forget it'.
	array := Array new: 3.
	array at: 1 put: 'Language Impressions'.
	array at: 2 put: dict.
	array at: 3 put: Date today.
	xmlString := array sixxString.
	Transcript
		cr;
		show: '##This is sixx xml instance##'.
	Transcript
		cr;
		show: xmlString.
	^xmlString!

example2
	"SixxExamples example2"

	"Read a SIXX string and restore an instance (like #readFrom:)"

	| xmlString obj |
	xmlString := SixxExamples example1.
	obj := Object readSixxFrom: xmlString.
	obj inspect!

example3
	"SixxExamples example3"

	"Resolve circular and shared objects"

	| rootOrdered sharedDict subOrdered subArray xmlString obj |
	rootOrdered := OrderedCollection new.
	sharedDict := Dictionary new.
	sharedDict at: #hello put: 'Hello'.
	sharedDict at: #recurHello put: sharedDict.
	subOrdered := OrderedCollection new.
	subOrdered add: sharedDict.
	subOrdered add: Time now.
	subArray := Array new: 2.
	subArray at: 1 put: sharedDict.
	subArray at: 2 put: Date today.
	rootOrdered
		add: subOrdered;
		add: subArray.
	xmlString := rootOrdered sixxString.
	Transcript
		cr;
		show: '##This is sixx xml instance##'.
	Transcript
		cr;
		show: xmlString.
	obj := Object readSixxFrom: xmlString.
	Transcript
		cr;
		show: '##Shared object comparison##'.
	Transcript
		cr;
		show: (obj first first = obj last first) printString!

example4
	"SixxExamples example4"

	"Save and load Preferences data"

	"| preferences |
	preferences := Preferences allPreferenceObjects sixxString.
	preferences := Object readSixxFrom: preferences.
	^preferences inspect."

	!

example5
	"SixxExamples example5"

	"Write object data to an external file"

	| sws |
	sws := SixxWriteStream newFileNamed: 'obj.sixx'.
	sws nextPut: Color red.
	"sws nextPut: Rectangle fromUser."
	sws nextPut: View subclasses.
	sws nextPutAll: View subclasses.	"note the differences"
	sws close!

example6
	"SixxExamples example6"

	"Read object data from an external file"

	| srs objects |
	srs := SixxReadStream readOnlyFileNamed: 'obj.sixx'.
	objects := OrderedCollection new.
	[srs atEnd] whileFalse: [objects add: srs next].
	srs close.
	objects inspect!

example7
	"SixxExamples example7"

	"Write object data to an external file"

	| sws dic |
	sws := SixxWriteStream newFileNamed: 'obj2.sixx'.
	sws nextPut: Color red.
	"sws nextPut: Rectangle fromUser."
	sws nextPut: true.
	sws nextPut: false.
	sws nextPut: $a.
	sws nextPut: $(.
	sws nextPut: (OrderedCollection with: 1 with: Date today).
	sws nextPut: Time now.
	sws nextPut: nil.
	sws nextPut: (ByteArray 
				with: 10
				with: 20
				with: 30).
	dic := Dictionary new.
	dic at: 'first' put: '111'.
	dic at: 'second' put: '222'.
	sws nextPut: dic.
	sws close! !
!SixxExamples class categoriesFor: #example1!examples!public! !
!SixxExamples class categoriesFor: #example2!examples!public! !
!SixxExamples class categoriesFor: #example3!examples!public! !
!SixxExamples class categoriesFor: #example4!examples!public! !
!SixxExamples class categoriesFor: #example5!examples!public! !
!SixxExamples class categoriesFor: #example6!examples!public! !
!SixxExamples class categoriesFor: #example7!examples!public! !

"Binary Globals"!

"Resources"!

