| package |
package := Package name: 'SIXX-InOut-Dolphin'.
package paxVersion: 0;
	basicComment: ''.


package methodNames
	add: #Color -> #sixxContentOn:indent:context:;
	add: #ColorRef -> #sixxContentOn:indent:context:;
	add: #DOUBLEArray -> #sixxContentOn:indent:context:;
	add: #FLOATArray -> #sixxContentOn:indent:context:;
	add: #RGB -> #sixxContentOn:indent:context:;
	add: #SystemColor -> #sixxContentOn:indent:context:;
	add: #WORDArray -> #sixxContentOn:indent:context:;
	add: 'Color class' -> #createInstanceOf:withSixxElement:;
	add: 'ColorRef class' -> #createInstanceOf:withSixxElement:;
	add: 'DOUBLEArray class' -> #createInstanceOf:withSixxElement:;
	add: 'FLOATArray class' -> #createInstanceOf:withSixxElement:;
	add: 'RGB class' -> #createInstanceOf:withSixxElement:;
	add: 'WORDArray class' -> #createInstanceOf:withSixxElement:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'SIXX-Core';
	yourself).

package!

"Class Definitions"!


"Global Aliases"!


"Loose Methods"!

!Color methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !
!Color categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!Color class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !
!Color class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!ColorRef methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self code printString! !
!ColorRef categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!ColorRef class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self fromInteger: (SixxXmlUtil characterDataFrom: sixxElement) asNumber! !
!ColorRef class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!DOUBLEArray methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: '#( '.
	self do: 
			[:each | 
			aStream
				nextPutAll: each printString;
				space].
	aStream nextPutAll: ')'! !
!DOUBLEArray categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!DOUBLEArray class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	| col |
	col := Array readFrom: (SixxXmlUtil characterDataFrom: sixxElement).
	^self withAll: col! !
!DOUBLEArray class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!FLOATArray methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: '#( '.
	self do: 
			[:each | 
			aStream
				nextPutAll: each printString;
				space].
	aStream nextPutAll: ')'! !
!FLOATArray categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!FLOATArray class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	| col |
	col := Array readFrom: (SixxXmlUtil characterDataFrom: sixxElement).
	^self withAll: col! !
!FLOATArray class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!RGB methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !
!RGB categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!RGB class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !
!RGB class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!SystemColor methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream
		nextPut: $(;
		display: self class;
		display: ' fromId: ';
		display: self id;
		nextPut: $)! !
!SystemColor categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!WORDArray methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: '#( '.
	self do: 
			[:each | 
			aStream
				nextPutAll: each printString;
				space].
	aStream nextPutAll: ')'! !
!WORDArray categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!WORDArray class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	| col |
	col := Array readFrom: (SixxXmlUtil characterDataFrom: sixxElement).
	^col asWordArray! !
!WORDArray class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

"Binary Globals"!

"Resources"!

