| package |
package := Package name: 'SIXX-InOut'.
package paxVersion: 0;
	basicComment: ''.


package methodNames
	add: #ArrayedCollection -> #initializeFromSixxElement:context:;
	add: #Behavior -> #classFromSixxElement:context:;
	add: #Behavior -> #createInstanceOf:withSixxElement:;
	add: #Behavior -> #fromSixxElement:context:;
	add: #Behavior -> #idFromSixxElement:;
	add: #Behavior -> #idrefFromSixxElement:;
	add: #Behavior -> #includesRefInstanceFromSixxElement:context:;
	add: #Behavior -> #nameFromSixxElement:;
	add: #Behavior -> #newInstanceFromSixxElement:context:;
	add: #Behavior -> #readSixxFrom:;
	add: #Behavior -> #readSixxFrom:context:;
	add: #Behavior -> #readSixxFromSixxElement:context:;
	add: #Behavior -> #refInstanceFromSixxElement:context:;
	add: #Behavior -> #typeFromSixxElement:;
	add: #Boolean -> #sixxContentOn:indent:context:;
	add: #ByteArray -> #sixxContentOn:indent:context:;
	add: #Character -> #sixxContentOn:indent:context:;
	add: #ClassDescription -> #sixxContentOn:indent:context:;
	add: #Collection -> #initializeFromSixxElement:context:;
	add: #Collection -> #sixxContentOn:indent:context:;
	add: #Date -> #sixxContentOn:indent:context:;
	add: #Date -> #sixxPrintString;
	add: #Dictionary -> #sixxContentOn:indent:context:;
	add: #Metaclass -> #createInstanceOf:withSixxElement:;
	add: #Number -> #sixxContentOn:indent:context:;
	add: #Object -> #initializeFromSixxElement:context:;
	add: #Object -> #sixxChildrenContentsFixedOn:indent:context:;
	add: #Object -> #sixxChildrenContentsOn:indent:context:;
	add: #Object -> #sixxChildrenContentsVariableOn:indent:context:;
	add: #Object -> #sixxContentOn:indent:context:;
	add: #Object -> #sixxIdAttribString:;
	add: #Object -> #sixxInstVarNamed:put:;
	add: #Object -> #sixxNameAttribString:;
	add: #Object -> #sixxOn:;
	add: #Object -> #sixxOn:indent:context:;
	add: #Object -> #sixxOn:name:indent:context:;
	add: #Object -> #sixxRefTagStartString:;
	add: #Object -> #sixxRefTagStartString:name:;
	add: #Object -> #sixxString;
	add: #Object -> #sixxTagEndString;
	add: #Object -> #sixxTagStartString:name:;
	add: #Object -> #sixxType;
	add: #Object -> #sixxTypeAttribString;
	add: #Point -> #sixxContentOn:indent:context:;
	add: #RunArray -> #initializeFromSixxElement:context:;
	add: #RunArray -> #runs;
	add: #RunArray -> #sixxContentOn:indent:context:;
	add: #RunArray -> #values;
	add: #String -> #sixxContentOn:indent:context:;
	add: #Time -> #print24:showSeconds:on:;
	add: #Time -> #sixxContentOn:indent:context:;
	add: #UndefinedObject -> #asSixxRepresentation;
	add: #UndefinedObject -> #sixxContentOn:indent:context:;
	add: #UndefinedObject -> #sixxOn:name:indent:context:;
	add: 'Boolean class' -> #createInstanceOf:withSixxElement:;
	add: 'ByteArray class' -> #createInstanceOf:withSixxElement:;
	add: 'Character class' -> #createInstanceOf:withSixxElement:;
	add: 'Collection class' -> #createInstanceOf:withSixxElement:;
	add: 'Date class' -> #createInstanceOf:withSixxElement:;
	add: 'Date class' -> #sixxMonthIndexToMonthName:;
	add: 'Date class' -> #sixxMonthNameToMonthIndex:;
	add: 'Number class' -> #createInstanceOf:withSixxElement:;
	add: 'Object class' -> #readFrom:;
	add: 'Point class' -> #createInstanceOf:withSixxElement:;
	add: 'String class' -> #createInstanceOf:withSixxElement:;
	add: 'Symbol class' -> #createInstanceOf:withSixxElement:;
	add: 'Time class' -> #createInstanceOf:withSixxElement:;
	add: 'Time class' -> #sixxReadFrom:;
	add: 'UndefinedObject class' -> #createInstanceOf:withSixxElement:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: 'SIXX-Core';
	yourself).

package!

"Class Definitions"!


"Global Aliases"!


"Loose Methods"!

!ArrayedCollection methodsFor!

initializeFromSixxElement: sixxElement context: aDictionary
	| idx |
	idx := 1.
	(SixxXmlUtil elementsFrom: sixxElement) do: 
			[:elem | 
			| childInst |
			(SixxXmlUtil isTextFrom: elem) 
				ifFalse: 
					[childInst := self class fromSixxElement: elem context: aDictionary.
					self at: idx put: childInst.
					idx := idx + 1]]! !
!ArrayedCollection categoriesFor: #initializeFromSixxElement:context:!initializing sixx!public! !

!Behavior methodsFor!

classFromSixxElement: sixxElement context: dictionary
	| isClassClass type className retClass |
	isClassClass := false.
	type := self typeFromSixxElement: sixxElement.
	type isNil ifTrue: [^nil].
	className := (type includes: Character space) 
				ifTrue: 
					[isClassClass := true.
					type upTo: Character space]
				ifFalse: [type].
	retClass := self environment at: className asSymbol ifAbsent: [].
	isClassClass ifTrue: [retClass := retClass class].
	^retClass isNil 
		ifTrue: 
			[SixxClassNotFound 
				signal: className
				element: sixxElement
				context: dictionary]
		ifFalse: [retClass]!

createInstanceOf: aClass withSixxElement: sixxElement
	"override if you like"

	^aClass new!

fromSixxElement: sixxElement context: aDictionary
	^(self includesRefInstanceFromSixxElement: sixxElement context: aDictionary) 
		ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]
		ifFalse: [self newInstanceFromSixxElement: sixxElement context: aDictionary]!

idFromSixxElement: sixxElement
	| id |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	id := SixxXmlUtil attributeAt: 'sixx.id' from: sixxElement.
	^id isNil ifFalse: [id asSymbol]!

idrefFromSixxElement: sixxElement
	| idref |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	idref := SixxXmlUtil attributeAt: 'sixx.idref' from: sixxElement.
	^idref isNil ifFalse: [idref asSymbol]!

includesRefInstanceFromSixxElement: sixxElement context: aDictionary
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^idref isNil ifTrue: [false] ifFalse: [aDictionary includesKey: idref]!

nameFromSixxElement: sixxElement
	| nm |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	nm := SixxXmlUtil attributeAt: 'sixx.name' from: sixxElement.
	^nm isNil ifFalse: [nm asSymbol]!

newInstanceFromSixxElement: sixxElement context: aDictionary
	| class inst |
	class := self classFromSixxElement: sixxElement context: aDictionary.
	class isNil 
		ifTrue: 
			[SixxClassNotFound 
				signal: (self typeFromSixxElement: sixxElement)
				element: sixxElement
				context: aDictionary].
	inst := class createInstanceOf: class withSixxElement: sixxElement.
	aDictionary at: (self idFromSixxElement: sixxElement) put: inst.
	inst initializeFromSixxElement: sixxElement context: aDictionary.
	^inst!

readSixxFrom: xmlStringOrStream
	^self readSixxFrom: xmlStringOrStream context: IdentityDictionary new!

readSixxFrom: xmlStringOrStream context: aDictionary
	| topElem |
	topElem := SixxXmlUtil parseXml: xmlStringOrStream.
	^self readSixxFromSixxElement: topElem context: aDictionary!

readSixxFromSixxElement: sixxElement context: aDictionary
	| rootClass typeAttr |
	typeAttr := self typeFromSixxElement: sixxElement.
	^typeAttr isNil 
		ifTrue: 
			[(self includesRefInstanceFromSixxElement: sixxElement context: aDictionary) 
				ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]]
		ifFalse: 
			[rootClass := self classFromSixxElement: sixxElement context: aDictionary.
			rootClass isNil ifFalse: [rootClass fromSixxElement: sixxElement context: aDictionary]]!

refInstanceFromSixxElement: sixxElement context: aDictionary
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^aDictionary at: idref!

typeFromSixxElement: sixxElement
	| type |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	type := SixxXmlUtil attributeAt: 'sixx.type' from: sixxElement.
	^type isNil ifFalse: [type asSymbol]! !
!Behavior categoriesFor: #classFromSixxElement:context:!private!private sixx! !
!Behavior categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !
!Behavior categoriesFor: #fromSixxElement:context:!private sixx!public! !
!Behavior categoriesFor: #idFromSixxElement:!private sixx!public! !
!Behavior categoriesFor: #idrefFromSixxElement:!private sixx!public! !
!Behavior categoriesFor: #includesRefInstanceFromSixxElement:context:!private sixx!public! !
!Behavior categoriesFor: #nameFromSixxElement:!private sixx!public! !
!Behavior categoriesFor: #newInstanceFromSixxElement:context:!private sixx!public! !
!Behavior categoriesFor: #readSixxFrom:!instance creation sixx!public! !
!Behavior categoriesFor: #readSixxFrom:context:!instance creation sixx!public! !
!Behavior categoriesFor: #readSixxFromSixxElement:context:!instance creation sixx!public! !
!Behavior categoriesFor: #refInstanceFromSixxElement:context:!private sixx!public! !
!Behavior categoriesFor: #typeFromSixxElement:!private sixx!public! !

!Boolean methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !
!Boolean categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!Boolean class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !
!Boolean class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!ByteArray methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: '#( '.
	self do: 
			[:each | 
			aStream
				nextPutAll: each printString;
				space].
	aStream nextPutAll: ')'! !
!ByteArray categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!ByteArray class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	| col |
	col := Array readFrom: (SixxXmlUtil characterDataFrom: sixxElement).
	^col asByteArray! !
!ByteArray class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!Character methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !
!Character categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!Character class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !
!Character class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!ClassDescription methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	| instVars startIndex |
	aStream cr.
	instVars := self class allInstVarNames.
	startIndex := Object class allInstVarNames size + 1.
	startIndex to: instVars size
		do: 
			[:idx | 
			(self instVarAt: idx) 
				sixxOn: aStream
				name: (instVars at: idx)
				indent: level + 1
				context: dictionary]! !
!ClassDescription categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!Collection methodsFor!

initializeFromSixxElement: sixxElement context: aDictionary
	(SixxXmlUtil elementsFrom: sixxElement) do: 
			[:elem | 
			| childInst |
			childInst := self class fromSixxElement: elem context: aDictionary.
			self add: childInst]!

sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self do: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level! !
!Collection categoriesFor: #initializeFromSixxElement:context:!initializing sixx!public! !
!Collection categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!Collection class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	"override if you like"

	^aClass new: (SixxXmlUtil elementsFrom: sixxElement) size! !
!Collection class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!Date methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxPrintString!

sixxPrintString
	| st |
	st := WriteStream on: String new.
	st nextPutAll: self dayOfMonth printString , ' '.
	st nextPutAll: (self class sixxMonthIndexToMonthName: self monthIndex) , ' '.
	st nextPutAll: self year printString.
	^st contents! !
!Date categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !
!Date categoriesFor: #sixxPrintString!printing sixx!public! !

!Date class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	| st day month monthStr year |
	st := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	day := (st upTo: Character space) asNumber.
	monthStr := st upTo: Character space.
	month := Date sixxMonthNameToMonthIndex: monthStr.
	year := st upToEnd asNumber.
	^Date 
		newDay: day
		monthNumber: month
		year: year!

sixxMonthIndexToMonthName: index
	index = 1 ifTrue: [^'January'].
	index = 2 ifTrue: [^'February'].
	index = 3 ifTrue: [^'March'].
	index = 4 ifTrue: [^'April'].
	index = 5 ifTrue: [^'May'].
	index = 6 ifTrue: [^'June'].
	index = 7 ifTrue: [^'July'].
	index = 8 ifTrue: [^'August'].
	index = 9 ifTrue: [^'September'].
	index = 10 ifTrue: [^'October'].
	index = 11 ifTrue: [^'November'].
	index = 12 ifTrue: [^'December'].
	^nil!

sixxMonthNameToMonthIndex: name
	name = 'January' ifTrue: [^1].
	name = 'February' ifTrue: [^2].
	name = 'March' ifTrue: [^3].
	name = 'April' ifTrue: [^4].
	name = 'May' ifTrue: [^5].
	name = 'June' ifTrue: [^6].
	name = 'July' ifTrue: [^7].
	name = 'August' ifTrue: [^8].
	name = 'September' ifTrue: [^9].
	name = 'October' ifTrue: [^10].
	name = 'November' ifTrue: [^11].
	name = 'December' ifTrue: [^12].
	^nil! !
!Date class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !
!Date class categoriesFor: #sixxMonthIndexToMonthName:!public!utility sixx! !
!Date class categoriesFor: #sixxMonthNameToMonthIndex:!public!utility sixx! !

!Dictionary methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self associationsDo: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level! !
!Dictionary categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!Metaclass methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self environment at: (aClass printString upTo: Character space) asSymbol! !
!Metaclass categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!Number methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self printString! !
!Number categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!Number class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^(SixxXmlUtil characterDataFrom: sixxElement) asNumber! !
!Number class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!Object methodsFor!

initializeFromSixxElement: sixxElement context: aDictionary
	(SixxXmlUtil elementsFrom: sixxElement) do: 
			[:elem | 
			| varName |
			(SixxXmlUtil isTextFrom: elem) 
				ifFalse: 
					[varName := self class nameFromSixxElement: elem.
					varName notNil 
						ifTrue: 
							[| childInst |
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]!

sixxChildrenContentsFixedOn: aStream indent: level context: dictionary
	| instVars ind |
	aStream cr.
	instVars := self class allInstVarNames.
	ind := 0.
	instVars do: 
			[:nm | 
			ind := ind + 1.
			(self instVarAt: ind) 
				sixxOn: aStream
				name: nm
				indent: level
				context: dictionary]!

sixxChildrenContentsOn: aStream indent: level context: dictionary
	self class isVariable 
		ifTrue: 
			[self 
				sixxChildrenContentsVariableOn: aStream
				indent: level
				context: dictionary]
		ifFalse: 
			[self 
				sixxChildrenContentsFixedOn: aStream
				indent: level
				context: dictionary]!

sixxChildrenContentsVariableOn: aStream indent: level context: dictionary
	self class isBits 
		ifTrue: 
			[aStream nextPutAll: '#( '.
			self do: 
					[:each | 
					aStream
						nextPutAll: each asString;
						space].
			aStream nextPutAll: ')']
		ifFalse: 
			[aStream cr.
			self do: 
					[:each | 
					each 
						sixxOn: aStream
						indent: level
						context: dictionary]]!

sixxContentOn: aStream indent: level context: dictionary
	"override if you like"

	self 
		sixxChildrenContentsOn: aStream
		indent: level + 1
		context: dictionary.
	aStream tab: level!

sixxIdAttribString: idString
	^'sixx.id="' , idString asString , '" '!

sixxInstVarNamed: instVarName put: aValue
	"override if you like"

	self instVarAt: (self class allInstVarNames indexOf: instVarName asString) put: aValue!

sixxNameAttribString: idString
	^'sixx.name="' , idString asString , '" '!

sixxOn: aStream
	self 
		sixxOn: aStream
		indent: 0
		context: IdentityDictionary new!

sixxOn: aStream indent: level context: dictionary
	^self 
		sixxOn: aStream
		name: nil
		indent: level
		context: dictionary!

sixxOn: aStream name: nameString indent: level context: dictionary
	aStream tab: level.
	(dictionary includesKey: self) 
		ifTrue: 
			[aStream nextPutAll: (self sixxRefTagStartString: (dictionary at: self) name: nameString)]
		ifFalse: 
			[| idStr |
			idStr := dictionary size printString.
			dictionary at: self put: idStr.
			aStream nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self 
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr!

sixxRefTagStartString: idString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	idString isNil ifFalse: [wStr nextPutAll: idString].
	wStr nextPutAll: '" >'.
	^wStr contents!

sixxRefTagStartString: idString name: nameString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	wStr nextPutAll: idString.
	wStr nextPutAll: '" '.
	nameString notNil 
		ifTrue: 
			[wStr nextPutAll: 'sixx.name="'.
			wStr nextPutAll: nameString.
			wStr nextPutAll: '" '].
	wStr nextPutAll: '>'.
	^wStr contents!

sixxString
	| wStr |
	wStr := (String new: 128) writeStream.
	self sixxOn: wStr.
	^wStr contents!

sixxTagEndString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '</sixx.object>'.
	^wStr contents!

sixxTagStartString: idString name: nameString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object '.
	idString isNil ifFalse: [wStr nextPutAll: (self sixxIdAttribString: idString)].
	nameString isNil ifFalse: [wStr nextPutAll: (self sixxNameAttribString: nameString)].
	wStr nextPutAll: self sixxTypeAttribString.
	wStr nextPutAll: '>'.
	^wStr contents!

sixxType
	^self class name!

sixxTypeAttribString
	^'sixx.type="' , self sixxType , '" '! !
!Object categoriesFor: #initializeFromSixxElement:context:!initializing sixx!public! !
!Object categoriesFor: #sixxChildrenContentsFixedOn:indent:context:!private!private sixx! !
!Object categoriesFor: #sixxChildrenContentsOn:indent:context:!private!private sixx! !
!Object categoriesFor: #sixxChildrenContentsVariableOn:indent:context:!private!private sixx! !
!Object categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !
!Object categoriesFor: #sixxIdAttribString:!private!private sixx! !
!Object categoriesFor: #sixxInstVarNamed:put:!initializing sixx!public! !
!Object categoriesFor: #sixxNameAttribString:!private!private sixx! !
!Object categoriesFor: #sixxOn:!printing sixx!public! !
!Object categoriesFor: #sixxOn:indent:context:!printing sixx!public! !
!Object categoriesFor: #sixxOn:name:indent:context:!printing sixx!public! !
!Object categoriesFor: #sixxRefTagStartString:!private!private sixx! !
!Object categoriesFor: #sixxRefTagStartString:name:!private!private sixx! !
!Object categoriesFor: #sixxString!printing sixx!public! !
!Object categoriesFor: #sixxTagEndString!private!private sixx! !
!Object categoriesFor: #sixxTagStartString:name:!private!private sixx! !
!Object categoriesFor: #sixxType!private!private sixx! !
!Object categoriesFor: #sixxTypeAttribString!private!private sixx! !

!Object class methodsFor!

readFrom: aStream
	"Create an object based on the contents of aStream."

	| object ok |
	ok := (aStream isKindOf: Stream) or: [aStream isKindOf: String].
	ok ifFalse: [^self error: 'expected String'].
	object := Compiler evaluate: aStream.
	(object isKindOf: self) ifFalse: [self error: self name , ' expected'].
	^object! !
!Object class categoriesFor: #readFrom:!instance creation sixx!public! !

!Point methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !
!Point categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!Point class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !
!Point class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!RunArray methodsFor!

initializeFromSixxElement: sixxElement context: aDictionary
	(SixxXmlUtil elementsFrom: sixxElement) do: 
			[:elem | 
			| varName |
			(SixxXmlUtil isTextFrom: elem) 
				ifFalse: 
					[varName := self class nameFromSixxElement: elem.
					varName notNil 
						ifTrue: 
							[| childInst |
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]!

runs
	^runs!

sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self runs 
		sixxOn: aStream
		name: 'runs'
		indent: level + 1
		context: dictionary.
	self values 
		sixxOn: aStream
		name: 'values'
		indent: level + 1
		context: dictionary.
	aStream tab: level!

values
	"Answer the values in the receiver."

	^values! !
!RunArray categoriesFor: #initializeFromSixxElement:context:!initializing sixx!printing sixx!public! !
!RunArray categoriesFor: #runs!accessing sixx!public! !
!RunArray categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !
!RunArray categoriesFor: #values!accessing sixx!public! !

!String methodsFor!

sixxContentOn: aStream indent: level context: dictionary
	^SixxXmlUtil writeXmlText: self on: aStream! !
!String categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!String class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^SixxXmlUtil characterDataFrom: sixxElement! !
!String class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!Symbol class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^(super createInstanceOf: aClass withSixxElement: sixxElement) asSymbol! !
!Symbol class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

!Time methodsFor!

print24: hr24 showSeconds: showSeconds on: aStream
	"Format is 'hh:mm:ss' or 'h:mm:ss am'  or, if showSeconds is false, 'hh:mm' or 'h:mm am'"

	| h m s |
	h := self hours.
	m := self minutes.
	s := self seconds.
	hr24 
		ifTrue: 
			[h < 10 ifTrue: [aStream nextPutAll: '0'].
			h printOn: aStream]
		ifFalse: 
			[h > 12 
				ifTrue: [h - 12 printOn: aStream]
				ifFalse: [h < 1 ifTrue: [12 printOn: aStream] ifFalse: [h printOn: aStream]]].
	aStream nextPutAll: (m < 10 ifTrue: [':0'] ifFalse: [':']).
	m printOn: aStream.
	showSeconds 
		ifTrue: 
			[aStream nextPutAll: (s < 10 ifTrue: [':0'] ifFalse: [':']).
			s printOn: aStream].
	hr24 ifFalse: [aStream nextPutAll: (h < 12 ifTrue: [' am'] ifFalse: [' pm'])]!

sixxContentOn: aStream indent: level context: dictionary
	| ws |
	ws := WriteStream on: String new.
	self 
		print24: false
		showSeconds: true
		on: ws.
	aStream nextPutAll: ws contents! !
!Time categoriesFor: #print24:showSeconds:on:!printing sixx!public! !
!Time categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !

!Time class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self sixxReadFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))!

sixxReadFrom: aStream
	"Read a Time from the stream in the form:
		<hour>:<minute>:<second> <am/pm>

	<minute>, <second> or <am/pm> may be omitted.  e.g. 1:59:30 pm; 8AM; 15:30"

	| hour minute second ampm |
	hour := Integer readFrom: aStream.
	minute := 0.
	second := 0.
	(aStream peekFor: $:) 
		ifTrue: 
			[minute := Integer readFrom: aStream.
			(aStream peekFor: $:) ifTrue: [second := Integer readFrom: aStream]].
	aStream skipSeparators.
	(aStream atEnd not and: [aStream peek isLetter]) 
		ifTrue: 
			[ampm := aStream next asLowercase.
			(ampm = $p and: [hour < 12]) ifTrue: [hour := hour + 12].
			(ampm = $a and: [hour = 12]) ifTrue: [hour := 0].
			(aStream peekFor: $m) ifFalse: [aStream peekFor: $M]].
	^self fromSeconds: 60 * (60 * hour + minute) + second

	"Time readFrom: (ReadStream on: '2:23:09 pm')"! !
!Time class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !
!Time class categoriesFor: #sixxReadFrom:!instance creation sixx!public! !

!UndefinedObject methodsFor!

asSixxRepresentation
	"For some Smalltalks which do not support nil key in IdentityDictionary"

	^#'SIXX-UndefinedObject(98ea8c30-2bf8-4d23-9da2-ad1ee0e29eff)'!

sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString!

sixxOn: aStream name: nameString indent: level context: dictionary
	| representation |
	representation := self asSixxRepresentation.
	aStream tab: level.
	(dictionary includesKey: representation) 
		ifTrue: 
			[aStream 
				nextPutAll: (self sixxRefTagStartString: (dictionary at: representation) name: nameString)]
		ifFalse: 
			[| idStr |
			idStr := dictionary size printString.
			dictionary at: representation put: idStr.
			aStream nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self 
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !
!UndefinedObject categoriesFor: #asSixxRepresentation!private!private sixx! !
!UndefinedObject categoriesFor: #sixxContentOn:indent:context:!printing sixx!public! !
!UndefinedObject categoriesFor: #sixxOn:name:indent:context:!printing sixx!public! !

!UndefinedObject class methodsFor!

createInstanceOf: aClass withSixxElement: sixxElement
	^self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !
!UndefinedObject class categoriesFor: #createInstanceOf:withSixxElement:!instance creation sixx!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

"Binary Globals"!

"Resources"!

